---
title: Credential
slug: Web/API/Credential
tags:
  - API
  - Credential Management API
  - Experimental
  - Interface
  - NeedsExample
  - Reference
  - credential management
---
<div>{{SeeCompatTable}}{{APIRef("Credential Management API")}}{{securecontext_header}}</div>

<p>The <strong><code>Credential</code></strong> interface of the <a href="/en-US/docs/Web/API/Credential_Management_API">Credential Management API</a> provides information about an entity (usually a user) as a prerequisite to a trust decision.</p>

<p><code>Credential</code> objects may be of 3 different types:</p>

<ul>
 <li>{{domxref("PasswordCredential")}}</li>
 <li>{{domxref("PublicKeyCredential")}}</li>
 <li>{{domxref("FederatedCredential")}}</li>
</ul>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("Credential.id")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("DOMString")}} containing the credential's identifier. This might be any one of a GUID, username, or email address.</dd>
 <dt>{{domxref("Credential.type")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("DOMString")}} containing the credential's type. Valid values are <code>password</code>, <code>federated</code> and <code>public-key</code>. (For {{domxref("PasswordCredential")}}, {{domxref("FederatedCredential")}} and {{domxref("PublicKeyCredential")}})</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<p>None.</p>

<h2 id="Methods">Methods</h2>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate line-numbers language-js"><code class="language-js"><span class="keyword token">let</span> pwdCredential <span class="operator token">=</span> <span class="keyword token">new</span> <span class="class-name token">PasswordCredential</span><span class="punctuation token">(</span><span class="punctuation token">{</span>
  id<span class="punctuation token">:</span> <span class="string token">"example-username"</span><span class="punctuation token">, // Username/ID</span>
  name<span class="punctuation token">:</span> <span class="string token">"John Doe"</span><span class="punctuation token">, // Display name</span>
  password<span class="punctuation token">:</span> <span class="string token">"correct horse battery staple" // Password</span>
<span class="punctuation token">}</span><span class="punctuation token">);

console.assert(</span>pwdCredential<span class="punctuation token">.type === "password");</span></code>
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Credential Management')}}</td>
   <td>{{Spec2('Credential Management')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Credential")}}</p>
